package com.xydl.demo.service.impl;

import com.xydl.demo.entity.NiecPoint;
import com.xydl.demo.entity.NiecSensor;
import com.xydl.demo.repository.NiecPointRepository;
import com.xydl.demo.repository.NiecSensorRepository;
import com.xydl.demo.service.NiecPointService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.persistence.criteria.Path;
import javax.persistence.criteria.Predicate;
import java.util.List;

@Service
@Slf4j
@Transactional(rollbackFor = Exception.class)
public class NiecPointServiceImpl implements NiecPointService {

    @Resource
    NiecPointRepository repository;

    @Override
    public List<NiecPoint> getList(Integer sensorId, Integer stype) {
        Specification<NiecPoint> specification = (root, query, builder) -> {
            Predicate predicate = builder.conjunction();
            predicate.getExpressions().add(builder.equal(root.get("sensorId"), sensorId));
            predicate.getExpressions().add(builder.equal(root.get("stype"), stype));
            return predicate;
        };
        List<NiecPoint> list = repository.findAll(specification, Sort.by("field"));
        return list;
    }
}
